local function print_meta(t)
  local meta = getmetatable(t)
  print(t[1]..': '..(meta or {'No metatable'})[1])
end
local m1 = { 'Metatable 1' }
local m2 = { 'Metatable 2' }
local t1 = { 'Table 1' }
local t2 = setmetatable({'Table 2'}, m1)
local t3 = setmetatable({'Table 3'}, m1)
print_meta(t1) --> Table 1: No metatable
print_meta(t2) --> Table 2: Metatable 1
print_meta(t3) --> Table 3: Metatable 1
setmetatable(t1, m2)
setmetatable(t2, nil)
print_meta(t1) --> Table 1: Metatable 2
print_meta(t2) --> Table 2: No metatable
print_meta(t3) --> Table 3: Metatable 1


local m1 = {__tostring = function(v)
  return v[1]
end}
local t1 = { 'Table 1' }
local t2 = setmetatable({'Table 2'}, m1)
local t3 = setmetatable({'Table 3'}, m1)
print(t1) --> table: 0x800114b8
print(t2) --> Table 2
print(t3) --> Table 3  
