local deflmeta = {
  add = function(obj, data) return zlib.deflate(obj.strm, data) end,
  flush = function(obj, mode) return zlib.deflateFlush(obj.strm, mode) end,
  __tostring = function(obj) return "ZLib deflater" end,
  __gc = function(obj) zlib.deflateEnd(obj.strm) end,
}
deflmeta.__index = deflmeta
function zlib.deflater(level)
  local strm = zlib.newstream()
  zlib.deflateInit(strm, level)
  return setmetatable({strm=strm}, deflmeta)
end

local inflmeta = {
  add = function(obj, data) return zlib.inflate(obj.strm, data) end,
  flush = function(obj, mode) return zlib.inflateFlush(obj.strm, mode) end,
  __tostring = function(obj) return "ZLib inflater" end,
  __gc = function(obj) zlib.inflateEnd(obj.strm) end,
}
inflmeta.__index = inflmeta
function zlib.inflater()
  local strm = zlib.newstream()
  zlib.inflateInit(strm)
  return setmetatable({strm=strm}, inflmeta)
end
